#include<allegro.h>

#ifndef __MAPA_H__
#define __MAPA_H__

#define MAPA_X        2000
#define MAPA_Y        1500
#define MAX_OBJETOS   147

extern DATAFILE *casas;
extern BITMAP *buffer;

void iniciar_objetos();

class objeto
{
    public:
    int x;
    int y;
    
    int x0;
    int y0;
    int x1;
    int y1;
    
    int tipo;
    
    BITMAP *bmp;
    
    void iniciar(int _x,int _y,int _tipo);
    void dibujar(BITMAP *donde);
    
}objetos[MAX_OBJETOS];


class mapa
{
    public:
    BITMAP *bmp;
    
    void iniciar();
    bool check_colision(int _x2,int _y2,int _x3,int _y3);
};



void objeto::iniciar(int _x,int _y,int _tipo)
{
     x=_x;
     y=_y;
     
     tipo=_tipo;
     
     if(tipo!=99)
     bmp=(BITMAP *)casas[tipo].dat;
     
     if(tipo==0)
     {
         x0=x;
         y0=y+36;
         x1=x+132;
         y1=y+160;
     }
     if(tipo==1 || tipo==2)
     {
         x0=x;
         y0=y+36;
         x1=x+101;
         y1=y+159;
     }
     if(tipo==3)
     {
         x0=x+36;
         y0=y+60;
         x1=x+130;
         y1=y+154;
     }
     if(tipo==4)
     {
         x0=x;
         y0=y;
         x1=x+123;
         y1=y+130;
     }
     if(tipo==5)
     {
         x0=x;
         y0=y;
         x1=x+66;
         y1=y+68;
     }
     if(tipo==6)
     {
         x0=x;
         y0=y;
         x1=x+50;
         y1=y+33;
     }
     if(tipo==7)
     {
         x0=x+3;
         y0=y+10;
         x1=x+54;
         y1=y+50;
     }
     if(tipo==8)
     {
         x0=x;
         y0=y+54;
         x1=x+150;
         y1=y+207;
     }
     if(tipo==9)
     {
         x0=x;
         y0=y;
         x1=x+77;
         y1=y+91;
     }
     if(tipo==10)
     {
         x0=x+6;
         y0=y+15;
         x1=x+57;
         y1=y+102;
     }
     if(tipo==11)
     {
         x0=x+3;
         y0=y+30;
         x1=x+78;
         y1=y+103;
     }     
     if(tipo==12)
     {
         x0=x+7;
         y0=y+35;
         x1=x+87;
         y1=y+111;
     }     
     if(tipo==13)
     {
         x0=x;
         y0=y;
         x1=x+117;
         y1=y+91;
     }     
     if(tipo==14)
     {
         x0=x+11;
         y0=y+15;
         x1=x+68;
         y1=y+103;
     }     
     if(tipo==15)
     {
         x0=x;
         y0=y;
         x1=x+22;
         y1=y+49;
     }     
     if(tipo==16)
     {
         x0=x+14;
         y0=y+32;
         x1=x+32;
         y1=y+56;
     }     
     
         

}

void objeto::dibujar(BITMAP *donde)
{
     draw_sprite(donde,bmp,x,y);
}


void mapa::iniciar()
{
     bmp=create_bitmap(MAPA_X,MAPA_Y);
     iniciar_objetos();
     clear_to_color(bmp,makecol(255,0,255));
     for(int a=0;a!=MAX_OBJETOS;a++)
     {
         if(objetos[a].tipo!=99)
         objetos[a].dibujar(bmp);
     }    
}


bool mapa::check_colision(int _x2,int _y2,int _x3,int _y3)
{
     for(int a=0;a!=MAX_OBJETOS;a++)
     {
         if(colision(objetos[a].x0,objetos[a].y0,objetos[a].x1,objetos[a].y1,_x2,_y2,_x3,_y3))
         {
             return true;
         }
     }
     if(_x3>MAPA_X || _y3>MAPA_Y || _x2<0 || _y2<0) 
     return true;
     
     return false; 
}


void iniciar_objetos()
{
     objetos[0].iniciar(90,80,1);
     objetos[1].iniciar(190,80,0);
     objetos[2].iniciar(322,80,2);

     objetos[3].iniciar(750,80,1);
     objetos[4].iniciar(850,80,0);
     objetos[5].iniciar(982,80,2);

     objetos[6].iniciar(90,320,1);
     objetos[7].iniciar(190,320,0);
     objetos[8].iniciar(322,320,2);

     objetos[9].iniciar(750,320,1);
     objetos[10].iniciar(850,320,3);
     objetos[11].iniciar(982,320,2);

     objetos[12].iniciar(520,50,8);

     objetos[13].iniciar(140,560,5);
     objetos[14].iniciar(220,560,5);
     objetos[15].iniciar(300,560,5);
     
     objetos[16].iniciar(90,640,6);
     objetos[17].iniciar(160,640,6);
     objetos[18].iniciar(230,640,6);
     objetos[19].iniciar(300,640,6);
     objetos[20].iniciar(370,640,6);

     objetos[21].iniciar(90,690,6);
     objetos[22].iniciar(160,690,6);
     objetos[23].iniciar(230,690,6);
     objetos[24].iniciar(300,690,6);
     objetos[25].iniciar(370,690,6);
     
     objetos[26].iniciar(540,350,4);
     
     objetos[27].iniciar(540,600,13);

     objetos[28].iniciar(540,680,15);
     objetos[29].iniciar(572,680,15);
     objetos[30].iniciar(604,680,15);
     objetos[31].iniciar(636,680,15);

     objetos[32].iniciar(90,800,1);
     objetos[33].iniciar(190,800,0);
     objetos[34].iniciar(322,800,2);

     objetos[35].iniciar(750,560,1);
     objetos[36].iniciar(850,560,0);
     objetos[37].iniciar(982,560,2);

     objetos[38].iniciar(750,800,1);
     objetos[39].iniciar(850,800,0);
     objetos[40].iniciar(982,800,2);
     
     objetos[41].iniciar(560,820,14);
     
     objetos[42].iniciar(90,1040,99);
     objetos[43].iniciar(180,1040,99);
     objetos[44].iniciar(270,1040,99);
     objetos[45].iniciar(360,1040,99);

     objetos[46].iniciar(90,1220,9);
     objetos[47].iniciar(180,1220,9);
     objetos[48].iniciar(270,1220,9);
     objetos[49].iniciar(360,1220,9);

     objetos[50].iniciar(560,1020,11);


     objetos[51].iniciar(572,1220,7);

     objetos[52].iniciar(750,1020,1);
     objetos[53].iniciar(850,1020,0);
     objetos[54].iniciar(982,1020,2);

     objetos[55].iniciar(750,1240,1);
     objetos[56].iniciar(850,1240,0);
     objetos[57].iniciar(982,1240,2);

     objetos[58].iniciar(90,1400,99);
     objetos[59].iniciar(180,1400,99);
     objetos[60].iniciar(270,1400,99);
     objetos[61].iniciar(360,1400,99);

     objetos[62].iniciar(1190,110,99);
     objetos[63].iniciar(1280,110,99);
     objetos[64].iniciar(1370,110,99);

     objetos[65].iniciar(1190,270,9);
     objetos[66].iniciar(1297,290,7);
     objetos[67].iniciar(1370,270,9);
     
     objetos[68].iniciar(1190,430,99);
     objetos[69].iniciar(1280,430,99);
     objetos[70].iniciar(1370,430,99);

     objetos[71].iniciar(1190,590,9);
     objetos[72].iniciar(1280,590,9);
     objetos[73].iniciar(1370,590,9);

     objetos[74].iniciar(1190,750,99);
     objetos[75].iniciar(1290,760,99);
     objetos[76].iniciar(1370,750,99);

     objetos[77].iniciar(1190,910,9);
     objetos[78].iniciar(1280,910,9);
     objetos[79].iniciar(1370,910,9);
     
     objetos[80].iniciar(1190,1070,99);
     objetos[81].iniciar(1280,1070,99);
     objetos[82].iniciar(1370,1070,99);

     objetos[83].iniciar(1190,1230,9);
     objetos[84].iniciar(1297,1250,7);
     objetos[85].iniciar(1370,1230,9);

     objetos[86].iniciar(1190,1390,99);
     objetos[87].iniciar(1280,1390,99);
     objetos[88].iniciar(1370,1390,99);

     objetos[89].iniciar(1600,80,10);
     objetos[90].iniciar(1690,80,10);
     objetos[91].iniciar(1780,80,10);

     objetos[92].iniciar(1880,80,12);

     objetos[93].iniciar(1600,300,10);
     objetos[94].iniciar(1690,300,10);
     objetos[95].iniciar(1780,300,10);
     objetos[96].iniciar(1870,300,10);

     objetos[97].iniciar(1600,480,16);
     objetos[98].iniciar(1650,480,16);
     objetos[99].iniciar(1700,480,16);
     objetos[100].iniciar(1750,480,16);
     objetos[101].iniciar(1800,480,16);
     objetos[102].iniciar(1850,480,16);
     objetos[103].iniciar(1900,480,16);
     objetos[104].iniciar(1950,480,16);

     objetos[105].iniciar(1625,510,16);
     objetos[106].iniciar(1675,510,16);
     objetos[107].iniciar(1725,510,16);
     objetos[108].iniciar(1775,510,16);
     objetos[109].iniciar(1825,510,16);
     objetos[110].iniciar(1875,510,16);
     objetos[111].iniciar(1925,510,16);

     objetos[112].iniciar(1600,540,16);
     objetos[113].iniciar(1650,540,16);
     objetos[114].iniciar(1700,540,16);
     objetos[115].iniciar(1750,540,16);
     objetos[116].iniciar(1800,540,16);
     objetos[117].iniciar(1850,540,16);
     objetos[118].iniciar(1900,540,16);
     objetos[119].iniciar(1950,540,16);

     objetos[120].iniciar(1625,570,16);
     objetos[121].iniciar(1675,570,16);
     objetos[122].iniciar(1725,570,16);
     objetos[123].iniciar(1775,570,16);
     objetos[124].iniciar(1825,570,16);
     objetos[125].iniciar(1875,570,16);
     objetos[126].iniciar(1925,570,16);

     objetos[127].iniciar(1600,600,16);
     objetos[128].iniciar(1650,600,16);
     objetos[129].iniciar(1700,600,16);
     objetos[130].iniciar(1750,600,16);
     objetos[131].iniciar(1800,600,16);
     objetos[132].iniciar(1850,600,16);
     objetos[133].iniciar(1900,600,16);
     objetos[134].iniciar(1950,600,16);
     
     objetos[135].iniciar(1675,660,11);
     objetos[136].iniciar(1765,660,14);
     objetos[137].iniciar(1855,660,11);
     
     objetos[138].iniciar(1650,850,1);
     objetos[139].iniciar(1750,850,0);
     objetos[140].iniciar(1878,850,2);

     objetos[141].iniciar(1650,1100,1);
     objetos[142].iniciar(1750,1100,3);
     objetos[143].iniciar(1878,1100,2);
     
     objetos[144].iniciar(1650,1350,99);
     objetos[145].iniciar(1750,1350,99);
     objetos[146].iniciar(1878,1350,99);
     
}




#endif
