#include<allegro.h>
#include "timer.h"

#ifndef __DIALOGO_H__
#define __DIALOGO_H__

#define MAX_DIALOGOS 49

DATAFILE *caras;
BITMAP *dialog;
int dialogo_actual=0;
int posicion_dialogo=0;
int estado_dialogo=0;
bool dialogo_activo=false;

struct sdialogo
{
       int cara;
       char nombre[50];
       char linea1[65];
       char linea2[65];
       char linea3[65];
};

sdialogo dialogos[MAX_DIALOGOS]= {
     { 1,  "Butch", "Welcome to the Training of Beethoven.", "My name is Butch and I will Teach you how to play.", "But first please tell me your name."},
     { 0,  "Beethoven", "My name is Beethoven. But you can call me Ludwig.", "", "" },
     { 1,  "Butch", "OK, Ludwig, pay fine attention, you can move the Train with the", "arrow keys. If you need HELP you can press enter. This", "will also pause the game." },
     { 1,  "Butch", "See the arrow in the middle upper part of screen?", "That indicates where you have to go. Just for practice, go to", "the witch's house. Don't worry, just follow the arrow." },
     { 1,  "Butch", "Good Work!. Come back to the central station when you feel", "you're ready.", ""},
     { 1,  "Butch", "Ready for the first mission, huh? It's not as easy as it seems.", "You've got a limited amount of time for the missions.", "But don't worry, you can play a mission again if you lose." },
     { 1,  "Butch", "Ah, and before the first mission, i want you to take a look at", "this ASCII ART I have just made.", "" },
     { 0,  "Beethoven", "Wow, that's cool!", "It's such an excellent ASCII ART.", "Yes, tht's what i have said, ASCII ART." },
     { 1,  "Butch", "OK, Enough of ASCII ART for now. go to Freddy's house. Be", "careful with the TIME. And remember, once you get there, go", "wherever he wants." },
     { 2,  "Freddy", "Hello!, nice train!", "", "" },
     { 0,  "Beethoven", "Where are you going Mr. Mercury?", "", "" }, //10
     { 2,  "Freddy", "First I'll go for some snacks.", "", "" },
     { 2,  "Freddy", "Now take me to the buy some Newspapers", "", "" },
     { 2,  "Freddy", "That's it, get me back to my house", "", "" },
     { 2,  "Freddy", "Why can't we give love that one more chance?", "", "" },
     { 0,  "Beethoven", "'cause love's such and old fashioned word and love", "dares you to care for the people on the edge of the night", "and love dares you to change our way of caring about ourselves." },
     { 2,  "Freddy", "Oh, thank you very much Mr. Ludwig.", "", "" },
     { 1,  "Butch", "Excellent job, Mr Ludwig. But i've got another job for you.", "Go to the house of a guy called john or something like that.", "" },
     { 3,  "John", "Hello.", "Take me to <TheSpookyPlace>", "" },
     { 0,  "Beethoven", "Are you really sure you want to go to <TheSpookyPlace>??", "", "" },
     { 3,  "John", "Yes, I need some inspiration and maybe that place helps me out", "", "" },//20
     { 3,  "John", "Changed my mind, Maybe the granary is a better place.", "", "" },
     { 3,  "John", "Take me to the restaurant.", "", "" },
     { 3,  "John", "And now take me to my house.", "", "" },
     { 3,  "John", "It's been a hard day's night, but everything seems to be right", "when i'm home.", "Thanks Ludwig." },
     { 6,  "????", "Gotta Catch 'em all!", "", "" },
     { 1,  "Butch", "Good Job!! You are doing so well. But now i've got a dangerous", "job. Someone called from <TheSpookyPlace>, i think he is in", "problems. Go and rescue him." },
     { 0,  "Beethoven", "Who are you???", "", "" },
     { 5,  "BatPig", "I'm Batman!!", "", "" },
     { 0,  "Beethoven", "No, you're not Batman!!, Batman is not a pig!!.", "", "" },//29
     { 5,  "The BatPig!", "Some demons in <TheSpookyPlace> turned me into a pig, but not", "any pig, The BatPig!!!. Just take me to the witch's house", "" },
     { 4,  "Batman", "Thank you, now take me again to <TheSpookyPlace>, i have some ", "business there....", "" },
     { 7,  "????", "Look out! here comes Spiderman", "", "" },
     { 0,  "Beethoven", "It looks like you don't learn from your errors...", "", "" },
     { 4,  "Batman", "Thanks, Ludwig. And don't worry about me, i'll be fine.", "", "" },//34
     { 1,  "Butch", "Good!!. I've got another job for you, go to Mr. Wonka's", "House. But be careful, he's kinda crazy....", "" },
     { 0,  "Beethoven", "Ok, i'll be careful.", "", "" },
     { 0,  "Beethoven", "Hello, Mr. Wonka!", "", "" },
     { 8,  "Willy", "I HAVE LOST MY MIND!!", "I HAVE LOST MY MIND!!", "I HAVE LOST MY MIND!!" },
     { 0,  "Beethoven", "Hey, where do you wanna go?", "", "" },
     { 8,  "Willy", "Take me Far AWAY wherE NOBODY RemEMBER Me", "", "" }, //40
     { 0,  "Beethoven", "Why are you so crazy, Mr. Wonka??", "", "" },
     { 8,  "Willy", "You don't really wanna know", "", "" },
     { 0,  "Beethoven", "no, you're wrong, i REALLY wanna know", "", "" },
     { 8,  "Willy", "mmmm... I am crazy, i've lost my mind.", "YOU KNOW WHY? YOU KNOW WHY?", "It's because......." },
     { 0,  "Beethoven", "I HAVE LOST MY MIND!!", "I HAVE LOST MY MIND!!", "I HAVE LOST MY MIND!!" },
     { 4,  "Batman", "Poor Ludwig, he just wanted to live... but now he lost", "his mind... it's a shame... I'm so sad....", "" },
     { 0,  "Beethoven", "Hey Batman, I'm Crazy!!!!!!.", "And I'm crazy because.....", "" }
};

void show_dialogo()
{
     if(contador2>0)
     {
       if(dialogo_activo)
       {
          if(estado_dialogo==0)
          {
              textprintf_ex(dialog, font, 110+(posicion_dialogo*8), 29, makecol(255,255,255), -1, "%c", dialogos[dialogo_actual].linea1[posicion_dialogo]);
              posicion_dialogo++;
              if(dialogos[dialogo_actual].linea1[posicion_dialogo]=='\0')
              {
                  estado_dialogo=1;
                  posicion_dialogo=0;
              }
          }
          else if(estado_dialogo==1)
          {
              textprintf_ex(dialog, font, 110+(posicion_dialogo*8), 43, makecol(255,255,255), -1, "%c", dialogos[dialogo_actual].linea2[posicion_dialogo]);
              posicion_dialogo++;
              if(dialogos[dialogo_actual].linea2[posicion_dialogo]=='\0')
              {
                  estado_dialogo=2;
                  posicion_dialogo=0;
              }
          }
          else if(estado_dialogo==2)
          {
              textprintf_ex(dialog, font, 110+(posicion_dialogo*8), 57, makecol(255,255,255), -1, "%c", dialogos[dialogo_actual].linea3[posicion_dialogo]);
              if(dialogos[dialogo_actual].linea3[posicion_dialogo]=='\0')
              {
                  estado_dialogo=3;
                  posicion_dialogo=0;
                  dialogo_activo=false;
              }
              posicion_dialogo++;
          }
        }
          contador2--;
     }
}


void cambiar_dialogo(int cual)
{
     clear(dialog);
     dialogo_actual=cual;
     posicion_dialogo=0;
     estado_dialogo=0;
     dialogo_activo=true;
     draw_sprite(dialog,(BITMAP*)caras[dialogos[dialogo_actual].cara].dat,50,15);
     textprintf_ex(dialog, font, 110, 15, makecol(255,255,255), -1, "%s:", dialogos[dialogo_actual].nombre);
}
     
#endif
