#include"dialogo.h"
#include"flecha.h"
#include"locomotora.h"
#include"camara.h"
#include"contador.h"

#ifndef __MISIONES_H__
#define __MISIONES_H__

#define MAX_MISIONES 20

int mision_actual=0;
int objetivo_actual;

extern locomotora   player1;
extern camara       camara1;
extern BITMAP       *buffer;

class objetivo
{
      public:
       int objetivo_x;
       int objetivo_y;
       
       int color;
       bool rojo_a_blanco;
       
       bool objetivo_cumplido;
       
       void update();
       void dibujar();
};

objetivo mision_1[MAX_MISIONES];


void objetivo::update()
{
     if(colision(player1.x0,player1.y0,player1.x1,player1.y1,objetivo_x-20,objetivo_y-20,objetivo_x+20,objetivo_y+20) && player1.velocidad==0)
     {
         objetivo_cumplido=true;
         if(mision_actual!=MAX_MISIONES)
         {
             mision_actual++;
             reloj_encendido=true;
             set_tiempo(15,0);
         }
     }
     
     if(rojo_a_blanco)
     color++;
     else
     color--;
     
     if(color>190) rojo_a_blanco=false; 
     if(color<30)   rojo_a_blanco=true;
}


void objetivo::dibujar()
{
     if(!objetivo_cumplido)
     {
     if(objetivo_x-camara1.x>0 && objetivo_x-camara1.x<640 && objetivo_y-camara1.y>0 && objetivo_y-camara1.y<480)
     ellipsefill(buffer,objetivo_x-camara1.x,objetivo_y-camara1.y,40,30,makecol(215,color,color));
     }
}


void iniciar_misiones()
{
     mision_1[0].objetivo_x=600; //witch's house
     mision_1[0].objetivo_y=980;
     mision_1[1].objetivo_x=610; //central
     mision_1[1].objetivo_y=545;
     mision_1[2].objetivo_x=130; //freddy's house
     mision_1[2].objetivo_y=1000;
     
     mision_1[3].objetivo_x=440; //snacks
     mision_1[3].objetivo_y=600;
     mision_1[4].objetivo_x=1330; //newspaper
     mision_1[4].objetivo_y=1350;
     mision_1[5].objetivo_x=130; //freddy's house
     mision_1[5].objetivo_y=1000;
     
     mision_1[6].objetivo_x=610; //central
     mision_1[6].objetivo_y=545;     
     mision_1[7].objetivo_x=125; //john's house
     mision_1[7].objetivo_y=275;     
     mision_1[8].objetivo_x=1810; //spooky
     mision_1[8].objetivo_y=810;   
       
     mision_1[9].objetivo_x=1850; //granary
     mision_1[9].objetivo_y=220;     
     mision_1[10].objetivo_x=620; //hotel
     mision_1[10].objetivo_y=315;     
     mision_1[11].objetivo_x=125; //john's house
     mision_1[11].objetivo_y=275;     
     mision_1[12].objetivo_x=610; //central
     mision_1[12].objetivo_y=545;
     
     mision_1[13].objetivo_x=1810; //spooky
     mision_1[13].objetivo_y=810;     
     mision_1[14].objetivo_x=600;  //witch's house
     mision_1[14].objetivo_y=980;     
     mision_1[15].objetivo_x=1810; //spooky
     mision_1[15].objetivo_y=810;
     
     mision_1[16].objetivo_x=610; //central
     mision_1[16].objetivo_y=545;   
       
     mision_1[17].objetivo_x=930; //wonka's house
     mision_1[17].objetivo_y=995;     
     mision_1[18].objetivo_x=1850; //far, far away
     mision_1[18].objetivo_y=30;
  
     mision_1[19].objetivo_x=0; //nowhere
     mision_1[19].objetivo_y=0;
}
     
     

#endif
    
     
     
